/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2015,2016          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#) 1.7 src/ppe/hpct/source/src/gpm/include/gpm.h, ppe.hpct, ppe_rneon, rneon1645a 16/11/14 13:54:56 */

#include <stdint.h>
#include <errno.h>

#ifndef GPM_H
#define GPM_H

#define GPM_OK              0 
#define GPM_ENOMEM          ENOMEM
#define GPM_EINVAL          EINVAL
#define GPM_ENODEV          ENODEV
#define GPM_ENOINIT         200
#define GPM_ENOEVENT        201
#define GPM_ENOLIBS         203
#define GPM_ENOSUPP         204
#define GPM_ENOSTATIC       205
#define GPM_ECUDA           206
#define GPM_ECUPTI          207
#define GPM_ENOREC          208
#define GPM_EFOPEN          220
#define GPM_EMISC           240

#if defined(__CUDACC__) || defined(__cplusplus)
extern "C" {
#endif

int gpm_init_component(void);
int gpm_init(void);
int gpm_terminate(void);
int gpm_start(void);
int gpm_Tstart(void);
int gpm_stop(void);
int gpm_Tstop(void);
int gpm_event_init_control_state(void);
int gpm_event_update_control_state(unsigned int *, int);
int gpm_event_code_to_name(unsigned int, char *, int);
int gpm_event_code_to_descr(unsigned int, char *, int);
int gpm_event_name_to_code(char *, unsigned int *);
int gpm_event_name_to_id(char *, unsigned int *);
int gpm_metric_init_control_state(void);
int gpm_metric_update_control_state(unsigned int *, int);
int gpm_metric_name_to_code(char *, unsigned int *);
int gpm_metric_name_to_id(char *, unsigned int *);
int gpm_get_events_from_ev(unsigned int **, int *);
int gpm_get_metrics_from_ev(unsigned int **, int *);

#if defined(__CUDACC__) || defined(__cplusplus)
};
#endif
#endif
