/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008,2016          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

/*
 * 10/16/2008 caf 153883 - change return void *MT_get_calleraddress
 */
#ifndef _MPT_H
#define _MPT_H

#include <stdio.h>
#include <stdlib.h>

#include "mpt_common.h"

#define COUNTS          1000
#define BYTES           1001
#define COMMUNICATIONTIME 1002
#define STACK           1003
#define HEAP            1004
#define MAXSTACKFUNC    1005
#define ELAPSEDTIME     1006
#define AVGHOPS         1007

/*----------------------------------*/
/* functions called by the profiler */
/*----------------------------------*/
int MT_trace_event(int);
int MT_output_trace(int);
int MT_output_text(void);

/*----------------------------------*/
/* utility function prototype       */
/*----------------------------------*/

long long MT_get_mpi_counts(int);       /* number of calls for a MPI */
double MT_get_mpi_bytes(int);   /* size of data tranfer for a MPI */
double MT_get_mpi_time(int);    /* time used for a MPI */
double MT_get_time(void);       /* time from the MPI_Init */
double MT_get_elapsed_time(void);       /* time between MPI_Finalize and MPI_Init */

char *MT_get_mpi_name(int);     /* name for a MPI */

int MT_get_tracebufferinfo(struct MT_tracebufferstruct *);      /* info for trace buffer */
int MT_get_memoryinfo(struct MT_memorystruct *);        /* info for the stack/heap */
void *MT_get_calleraddress(int level);  /* info for the caller */
int MT_get_callerinfo(void *, struct MT_callerstruct *);        /* get caller detailed info */

int MT_get_allresults(int, int, struct MT_summarystruct *);     /* get global info */

int MT_print_message_size_dist(FILE *);

void MT_trace_start(void);
void MT_trace_stop(void);

#ifdef BGL                      /* BGL only */
double MT_get_avg_hops(void);   /* average hops each MPI message travels */
void MT_get_environment(struct MT_envstruct *); /* self id info e.g., mpi rank */
void MT_get_layout(struct MT_layoutstruct *);
void MT_print_flat_profile(FILE *);
void MT_print_memory_stats(FILE *);
#endif /* BGL only */

#endif /* define _MPT_H */
