/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2016               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef _MT_COMMON_H
#define _MT_COMMON_H

/*----------------------------------------------------------*/
/*    define a structure to hold summarized info            */
/*----------------------------------------------------------*/
struct MT_summarystruct {
  int min_rank;
  int max_rank;
  int med_rank;

  void *min_result;
  void *max_result;
  void *med_result;
  void *avg_result;
  void *sum_result;

  void *all_result;
  void *sorted_all_result;
  int *sorted_rank;
  int sdf_keep_data;
};

struct MT_envstruct {
  int mpirank;
  int xCoord;
  int yCoord;
  int zCoord;
  int xSize;
  int ySize;
  int zSize;
  int procid;
  int ntasks;
  double clockHz;
  int nmpi;
};

struct MT_tracebufferstruct {
  int number_events;
  double total_buffer;          /* in terms of MBytes */
  double used_buffer;
  double free_buffer;
};

struct MT_memorystruct {
  unsigned int max_stack_address;
  unsigned int min_stack_address;
  unsigned int max_heap_address;
};

#ifndef MT_CALLERSTRUCT
#define MT_CALLERSTRUCT
struct MT_callerstruct {
  char *filepath;
  char *filename;
  char *funcname;
  int lineno;
};
#endif

struct MT_layoutstruct {
  int *xCoord;
  int *yCoord;
  int *zCoord;
  int *procid;
};

#endif
